/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { VisibilityDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { VisibilityDtoResponse } from '../../@coscine/model';
/**
 * VisibilityApi - axios parameter creator
 * @export
 */
export const VisibilityApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2VisibilitiesOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/visibilities`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all visibilities.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVisibilities: async (pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/visibilities`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves a visibility by ID.
         * @param {string} visibilityId The ID of the visibility.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVisibility: async (visibilityId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'visibilityId' is not null or undefined
            assertParamExists('getVisibility', 'visibilityId', visibilityId)
            const localVarPath = `/api/v2/visibilities/{visibilityId}`
                .replace(`{${"visibilityId"}}`, encodeURIComponent(String(visibilityId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * VisibilityApi - functional programming interface
 * @export
 */
export const VisibilityApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = VisibilityApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2VisibilitiesOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2VisibilitiesOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['VisibilityApi.apiV2VisibilitiesOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all visibilities.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getVisibilities(pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VisibilityDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getVisibilities(pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['VisibilityApi.getVisibilities']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves a visibility by ID.
         * @param {string} visibilityId The ID of the visibility.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getVisibility(visibilityId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VisibilityDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getVisibility(visibilityId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['VisibilityApi.getVisibility']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * VisibilityApi - factory interface
 * @export
 */
export const VisibilityApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = VisibilityApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2VisibilitiesOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2VisibilitiesOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all visibilities.
         * @param {VisibilityApiGetVisibilitiesRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVisibilities(requestParameters: VisibilityApiGetVisibilitiesRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<VisibilityDtoPagedResponse> {
            return localVarFp.getVisibilities(requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves a visibility by ID.
         * @param {VisibilityApiGetVisibilityRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVisibility(requestParameters: VisibilityApiGetVisibilityRequest, options?: RawAxiosRequestConfig): AxiosPromise<VisibilityDtoResponse> {
            return localVarFp.getVisibility(requestParameters.visibilityId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getVisibilities operation in VisibilityApi.
 * @export
 * @interface VisibilityApiGetVisibilitiesRequest
 */
export interface VisibilityApiGetVisibilitiesRequest {
    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof VisibilityApiGetVisibilities
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof VisibilityApiGetVisibilities
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof VisibilityApiGetVisibilities
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getVisibility operation in VisibilityApi.
 * @export
 * @interface VisibilityApiGetVisibilityRequest
 */
export interface VisibilityApiGetVisibilityRequest {
    /**
     * The ID of the visibility.
     * @type {string}
     * @memberof VisibilityApiGetVisibility
     */
    readonly visibilityId: string
}

/**
 * VisibilityApi - object-oriented interface
 * @export
 * @class VisibilityApi
 * @extends {BaseAPI}
 */
export class VisibilityApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VisibilityApi
     */
    public apiV2VisibilitiesOptions(options?: RawAxiosRequestConfig) {
        return VisibilityApiFp(this.configuration).apiV2VisibilitiesOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all visibilities.
     * @param {VisibilityApiGetVisibilitiesRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VisibilityApi
     */
    public getVisibilities(requestParameters: VisibilityApiGetVisibilitiesRequest = {}, options?: RawAxiosRequestConfig) {
        return VisibilityApiFp(this.configuration).getVisibilities(requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves a visibility by ID.
     * @param {VisibilityApiGetVisibilityRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VisibilityApi
     */
    public getVisibility(requestParameters: VisibilityApiGetVisibilityRequest, options?: RawAxiosRequestConfig) {
        return VisibilityApiFp(this.configuration).getVisibility(requestParameters.visibilityId, options).then((request) => request(this.axios, this.basePath));
    }
}

